



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JSON格式解析和libjson使用简介(关于cjson的使用示例)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JSON格式解析和libjson使用简介(关于cjson的使用示例)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 18:18:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>JSON格式解析和libjson使用简介</p>
<p>在阅读本文之前，请先阅读下《Rss&nbsp;Reader实例开发之系统设计》一文。</p>
<p>Rss&nbsp;Reader实例开发中，进行网络数据交换时主要使用到了两种数据格式：JSON与XML。本文主要介绍JSON格式的简单概念及JSON在Rss&nbsp;Reader中的应用，XML格式的使用将在下一篇文章做介绍。</p>
<p>JSON简介：</p>
<p>JSON(JavaScript&nbsp;Object&nbsp;Notation)&nbsp;是一种轻量级的数据交换格式，可以把JSON的结构理解成无序的、可嵌套的key-value键值对集合，这些key-value键值对是以结构体或数组的形式来组织的。同一级的key-value键值对之间是用一个&ldquo;,&rdquo;（逗号）隔开，每个key-value键值对是由一个key后面紧接一个&ldquo;:&rdquo;（冒号），冒号后面是这个key对应的value。Key是一个word，由大小写字母、下划线及数字组成，可以由双引号封闭，也可以不加双引号；而value的取值集为：Number、Boolean(true或false)、null、String、Object及Array，如图一：</p>
</div>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141111103520161" /></p>
<p>（图一）</p>
<p>1、Number：数值，包括整形数与浮点数，如：123、0.83、-2.7e10。其结构如图二：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141111103540566" /></p>
<p>（图二）</p>
<p>2、String：字符串，是以双引号封闭起来的一串字符，使用反斜杠来转义，如：\\、\n等，JSON中字符串的概念与C/C++或者JAVA语言里的字符串概念差不多，如：&rdquo;abc&rdquo;。其结构如图三：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141111103603311" /></p>
<p>（图三）</p>
<p>3、Object：对象，也可理解成一个结构体，是以一对大括号封闭起来的无序的key-value键值对集合，例如：{name:"Susan",&nbsp;age:27,&nbsp;birthday:{year:1984,&nbsp;month:2,&nbsp;day:11}}；也可以写成：{"name":"Susan",&nbsp;"age":27,&nbsp;"birthday":{"year":1984,&nbsp;"month":2,&nbsp;"day":11}}；其结构如图四：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141111103658005" /></p>
<p>（图四）</p>
<p>4、Array：数组，JSON的数组是一个以中括号封闭起来的value的集合，即数组内的各个成员的数据类型可以不一样，这一点就跟C/JAVA的数组概念不同了。每个value之间是由一个&ldquo;,&rdquo;(逗号)隔开，例如：[123,&nbsp;abc,&nbsp;false,&nbsp;{name:mj}]；其结构如图五：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141111103731997" /></p>
<p>（图五）</p>
<p>关于JSON的详细说明与教程请自行到网络上搜索，有很多。</p>
<p>下面我们就来动手写一个例子：</p>
<div>
<div>&nbsp;</div>
<p>{</p>
<p>result:true,</p>
<p>root:{</p>
<p>version:"201007091640",</p>
<p>channels:[</p>
<p>{</p>
<p>name:"新闻中心",</p>
<p>subchnls:[</p>
<p>{</p>
<p>title:"焦点新闻",</p>
<p>link:"http://news.mtc.sohu.com/news/channel/1/news.rss",</p>
<p>desc:"家事、国事、天下事"</p>
<p>},</p>
<p>{</p>
<p>title:"新闻频道",</p>
<p>link:"http://news.mtc.sohu.com/news/channel/2/news.rss",</p>
<p>desc:"让您实时掌握国际动态"</p>
<p>},</p>
<p>{</p>
<p>title:"军事频道",</p>
<p>link:"http://news.mtc.sohu.com/news/channel/3/news.rss",</p>
<p>desc:"军事"</p>
<p>}</p>
<p>]</p>
<p>},</p>
<p>{</p>
<p>name:"体育新闻",</p>
<p>subchnls:[</p>
<p>{</p>
<p>title:"体育要闻汇总",</p>
<p>link:"http://news.mtc.sohu.com/news/channel/4/news.rss",</p>
<p>desc:"erewr"</p>
<p>},</p>
<p>{</p>
<p>title:"国际足坛",</p>
<p>link:"http://news.mtc.sohu.com/news/channel/5/news.rss",</p>
<p>desc:"werewr"</p>
<p>}</p>
<p>]</p>
<p>}</p>
<p>]</p>
<p>}</p>
<p>}</p>
</div>
<p>这段JSON描述了一个对象（最外层大括号包围的部分），为了方便区分，我们就将其称为对象A吧。对象A有两个Item（即key-value键值对），一个是result，其值为true；一个是root，其值为一个对象，称为对象B。对象B也有两个Item，一个是version，其值为一个字串&rdquo;&nbsp;201007091640&rdquo;；一个是channels，其值是一个数组，而数组的成员都是一个对象，每个对象又包含两个Item，一个是name，值分别为字串"新闻中心"和"体育新闻"；一个是subchnls，值都是数组，每个数组又分别有若干个成员，每个subchnls成员也都是一个对象，每个对象都有三个Item：title、link和desc。也许你看到这，已经是一头大汗了，不过没关系，我们来帖张这段JSON文本对应的结构图，有图就有真相，请看图六：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141111103759344" /></p>
<p>（图六：黑色实线为对象，虚线为值，橙色实线为数组）</p>
<p>在RssReader中使用cJSON：</p>
<p>在RssReader中使用了开源库cJSON来解析JSON，所以在此就介绍下cJSON的使用：</p>
<p>在CJSON中，一个key-value键值对被解析并存放在一个cJSON结构体变量中，其value取值集为：FALSE，TRUE，NULL，NUMBER，STRING，OBJECT，ARRAY。它们分别被存放在CJSON对象的child、valuestring、valueint、valuedouble变量中，而用于判断某个CJSON对象value的数据类型则是CJSON对象的type变量，其取值范围与CJSON对象的value集是一一对应的，如：cJSON_False对应FALSE。<br />cJSON&nbsp;Types:</p>
<div>
<div>&nbsp;</div>
<p>#define&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cJSON_False&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0</p>
<p>#define&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cJSON_True&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1</p>
<p>#define&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cJSON_NULL&nbsp;&nbsp;2</p>
<p>#define&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cJSON_Number&nbsp;&nbsp;&nbsp;&nbsp;3</p>
<p>#define&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cJSON_String&nbsp;&nbsp;&nbsp;&nbsp;4</p>
<p>#define&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cJSON_Array&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5</p>
<p>#define&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cJSON_Object&nbsp;&nbsp;&nbsp;&nbsp;6</p>
</div>
<p>cJSON&nbsp;结构体:</p>
<div>
<div>&nbsp;</div>
<p>typedef&nbsp;struct&nbsp;cJSON</p>
<p>{</p>
<p>struct&nbsp;cJSON&nbsp;*next,*prev;&nbsp;&nbsp;&nbsp;//指向上一项/下一项</p>
<p>struct&nbsp;cJSON&nbsp;*child;&nbsp;&nbsp;&nbsp;&nbsp;//指向下一级，也就是当type为cJSON_Object或cJSON_Array时，此指针不为空。</p>
<p>int&nbsp;type;</p>
<p>char&nbsp;*valuestring;&nbsp;&nbsp;//&nbsp;当type为cJSON_String时</p>
<p>int&nbsp;valueint;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;当&nbsp;type为cJSON_Number时</p>
<p>double&nbsp;valuedouble;&nbsp;//当type为cJSON_Number时</p>
<p>char&nbsp;*string;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;当前项的名称，也就是key-value键值对的key</p>
<p>}&nbsp;cJSON;</p>
</div>
<p>在解析JSON过程中，从JSON格式描述的value数据到CJSON对象中存放的变量的一个映射关系如图七：<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141111103825755" /></p>
<p>（图七）</p>
<p>对CJSON格式的解析是使用cJSON_Parse()方法，其传入的参数是一个CJSON的Object/Array结构的字串，解析成功则返回一个cJSON结构体变量的指针，在使用完成后需要调用cJSON_Delete()将该指针销毁。CJSON是以树状结构来组织内部的各个cJSON结构体变量的，一般地，要使用某个cJSON结构体变量，需要调用cJSON_GetObjectItem()方法并根据其父节点的cJSON结构体变量指针与该项的名称来获取其指针，举个例子：</p>
<div>
<div>&nbsp;</div>
<p>bool&nbsp;bResult;</p>
<p>char&nbsp;jsonString[]&nbsp;=&nbsp;&ldquo;{result:true}&rdquo;;</p>
<p>//获取result的值true</p>
<p>cJSON*&nbsp;pItem&nbsp;=&nbsp;NULL;</p>
<p>cJSON*&nbsp;pRoot&nbsp;=&nbsp;cJSON_Parse&nbsp;(&nbsp;jsonString&nbsp;);</p>
<p>if&nbsp;(&nbsp;pRoot&nbsp;)</p>
<p>{</p>
<p>pItem&nbsp;=&nbsp;cJSON_GetObjectItem&nbsp;(&nbsp;pRoot,&nbsp;&ldquo;result&rdquo;&nbsp;);</p>
<p>if&nbsp;(&nbsp;pItem&nbsp;)</p>
<p>{</p>
<p>bResult&nbsp;=&nbsp;pItem-&gt;valueint;&nbsp;&nbsp;&nbsp;//由于result的值type为cJSON_False或cJSON_True，所以其值被存放在valueint变量中</p>
<p>}</p>
<p>cJSON_Delete&nbsp;(&nbsp;pRoot&nbsp;);</p>
<p>}</p>
</div>
<p>在上例中，不管result的值type为何类型，都是通过调用cJSON_GetObjectItem()方法获取其对应的cJSON结构体变量的指针，只是在处理其对应的值时会有所不同。如果result的值type为cJSON_Object，则需要通过调用cJSON_GetObjectItem(&nbsp;pItem,&nbsp;&ldquo;subItemKey&rdquo;)来获取其子Item的指针。在处理值type为cJSON_Array的Item时，就需要再用到另外两个API：cJSON_GetArraySize&nbsp;()和cJSON_GetArrayItem()。我们举个获取一个数组成员值的例子：</p>
<div>
<div>&nbsp;</div>
<p>char*&nbsp;out;</p>
<p>char&nbsp;jsonString[]&nbsp;=&nbsp;&ldquo;{colors:[\&ldquo;red\&rdquo;,&nbsp;\&ldquo;green\&rdquo;,\&nbsp;&ldquo;blue\&rdquo;,&nbsp;\&ldquo;yellow\&rdquo;,&nbsp;\&ldquo;white\&rdquo;]}&rdquo;;</p>
<p>cJSON*&nbsp;pArray&nbsp;=&nbsp;NULL;</p>
<p>cJSON*&nbsp;pRoot&nbsp;=&nbsp;cJSON_Parse&nbsp;(&nbsp;jsonString&nbsp;);</p>
<p>if&nbsp;(&nbsp;pRoot&nbsp;)</p>
<p>{</p>
<p>pArray&nbsp;=&nbsp;cJSON_GetObjectItem&nbsp;(&nbsp;pRoot,&nbsp;&ldquo;colors&rdquo;&nbsp;);</p>
<p>if&nbsp;(&nbsp;pArray&nbsp;)</p>
<p>{</p>
<p>cJSON*&nbsp;pArrayItem&nbsp;=&nbsp;NULL;</p>
<p>int&nbsp;nCount&nbsp;=&nbsp;cJSON_GetArraySize&nbsp;(&nbsp;pArray&nbsp;);&nbsp;//获取pArray数组的大小</p>
<p>for(&nbsp;int&nbsp;i&nbsp;=&nbsp;0;&nbsp;i&nbsp;&lt;&nbsp;nCount;&nbsp;i++)</p>
<p>{</p>
<p>pArrayItem&nbsp;=&nbsp;cJSON_GetArrayItem(pArray,&nbsp;i);</p>
<p>out&nbsp;=&nbsp;cJSON_Print(&nbsp;pArrayItem&nbsp;);&nbsp;&nbsp;&nbsp;&nbsp;//将pArrayItem的值以字串的形式打印到char型buffer上，cJSON_Print()会自动分配内存空间，用完需要释放内存。</p>
<p>SS_printf(&nbsp;&ldquo;array&nbsp;item&nbsp;%d:&nbsp;%s\n&rdquo;,&nbsp;i,&nbsp;out);</p>
<p>Free(&nbsp;out&nbsp;);</p>
<p>}</p>
<p>}</p>
<p>cJSON_Delete&nbsp;(&nbsp;pRoot&nbsp;);</p>
<p>}</p>
</div>
<p>在提取一个复杂的JSON格式的数据时，也只是将以上两个例子使用到的方法进行组合调用罢了。所以对CJSON提供的API的使用是很简单有效的。有了以上知识的了解，我们就可以编写一些代码将例一中的JSON解析并提取其中的数据，还是贴点代码才是硬道理，代码如下：</p>
<p>TChannelsData.h:</p>
<div>
<div>&nbsp;</div>
<p>/**&nbsp;子频道信息结构体</p>
<p>*</p>
<p>*/</p>
<p>struct&nbsp;SUBCHNL_DATA</p>
<p>{</p>
<p>SUBCHNL_DATA();</p>
<p>void&nbsp;clear();</p>
<p>TUChar&nbsp;*&nbsp;m_title;</p>
<p>char&nbsp;*&nbsp;m_link;</p>
<p>TUChar&nbsp;*&nbsp;m_desc;</p>
<p>};</p>
<p>/**&nbsp;大频道信息结构体</p>
<p>*</p>
<p>*/</p>
<p>struct&nbsp;CHANNEL_DATA</p>
<p>{</p>
<p>CHANNEL_DATA();</p>
<p>TUChar*&nbsp;m_pszTitle;</p>
<p>vector&nbsp;m_aSubChnlList;</p>
<p>};</p>
<p>//&hellip;&hellip;&hellip;&hellip;.</p>
<p>//&nbsp;TChannelsData&nbsp;类成员变量：RSSReaderConfig&nbsp;版本号</p>
<p>char&nbsp;m_pszVersion[32];</p>
<p>//&nbsp;TChannelsData&nbsp;类成员变量：频道信息列表</p>
<p>vector&nbsp;m_aChnlsList;</p>
<p>//&hellip;&hellip;&hellip;&hellip;.</p>
</div>
<p>TChannelsData.cpp:</p>
<div>
<div>&nbsp;</div>
<p>/**&nbsp;解析JSON格式的内容</p>
<p>*</p>
<p>*&nbsp;\param&nbsp;pszJsonText&nbsp;解析的JSON格式内容字串</p>
<p>*</p>
<p>*&nbsp;\return&nbsp;true:有更新数据;&nbsp;false:没有更新数据</p>
<p>*/</p>
<p>Boolean&nbsp;TChannelsData::ParseJson(char*&nbsp;pszJsonText)</p>
<p>{</p>
<p>//char*&nbsp;out;</p>
<p>cJSON*&nbsp;objJson;</p>
<p>objJson=&nbsp;cJSON_Parse(pszJsonText);</p>
<p>if&nbsp;(objJson)</p>
<p>{</p>
<p>//out=cJSON_Print(objJson);</p>
<p>cJSON*&nbsp;objRootItem&nbsp;=&nbsp;NULL;</p>
<p>//判断是否需要更新</p>
<p>objRootItem&nbsp;=&nbsp;cJSON_GetObjectItem(objJson,&nbsp;"result");</p>
<p>if&nbsp;(objRootItem)</p>
<p>{</p>
<p>if&nbsp;(!objRootItem-&gt;valueint)</p>
<p>{</p>
<p>return&nbsp;FALSE;</p>
<p>}</p>
<p>}</p>
<p>else</p>
<p>{</p>
<p>return&nbsp;FALSE;</p>
<p>}</p>
<p>//获取更新数据，根节点root</p>
<p>objRootItem&nbsp;=&nbsp;cJSON_GetObjectItem(objJson,&nbsp;"root");</p>
<p>if&nbsp;(objRootItem)</p>
<p>{</p>
<p>cJSON*&nbsp;objJsonItem&nbsp;=&nbsp;NULL;</p>
<p>//获取版本号</p>
<p>objJsonItem&nbsp;=&nbsp;cJSON_GetObjectItem(objRootItem,&nbsp;"version");</p>
<p>if&nbsp;(objJsonItem)</p>
<p>{</p>
<p>Int32&nbsp;nLen&nbsp;=&nbsp;strlen(objJsonItem-&gt;valuestring);</p>
<p>strncpy(m_pszVersion,&nbsp;objJsonItem-&gt;valuestring,&nbsp;(nLen&nbsp;&lt;&nbsp;32)?&nbsp;nLen&nbsp;:&nbsp;31);</p>
<p>}</p>
<p>//解析出大频道</p>
<p>_ParseChannels(objRootItem);</p>
<p>}</p>
<p>//SS_printf("=======[parse&nbsp;json]%s\n",out);</p>
<p>cJSON_Delete(objJson);</p>
<p>//free(out);</p>
<p>}</p>
<p>return&nbsp;TRUE;</p>
<p>}</p>
<p>/**&nbsp;解析出大频道</p>
<p>*</p>
<p>*&nbsp;\param&nbsp;pCJson&nbsp;cJSON对象指针</p>
<p>*</p>
<p>*&nbsp;\return&nbsp;void</p>
<p>*/</p>
<p>void&nbsp;TChannelsData::_ParseChannels(cJSON*&nbsp;pCJson)</p>
<p>{</p>
<p>cJSON*&nbsp;pJsonArray&nbsp;=&nbsp;NULL;</p>
<p>if&nbsp;(!pCJson)</p>
<p>{</p>
<p>return;</p>
<p>}</p>
<p>pJsonArray&nbsp;=&nbsp;cJSON_GetObjectItem(pCJson,&nbsp;"channels");</p>
<p>if(pJsonArray)</p>
<p>{</p>
<p>cJSON*&nbsp;pArrayItem&nbsp;=&nbsp;NULL;</p>
<p>cJSON*&nbsp;pJsonTemp&nbsp;=&nbsp;NULL;</p>
<p>Int32&nbsp;nSize&nbsp;=&nbsp;cJSON_GetArraySize(pJsonArray);</p>
<p>for&nbsp;(Int32&nbsp;i&nbsp;=&nbsp;0;&nbsp;i&nbsp;&lt;&nbsp;nSize;&nbsp;i++)</p>
<p>{</p>
<p>pArrayItem&nbsp;=&nbsp;cJSON_GetArrayItem(pJsonArray,&nbsp;i);</p>
<p>if&nbsp;(pArrayItem)</p>
<p>{</p>
<p>CHANNEL_DATA&nbsp;tChannelData;</p>
<p>Int32&nbsp;nLen&nbsp;=&nbsp;0;</p>
<p>//获取大频道名称</p>
<p>tChannelData.m_pszTitle&nbsp;=&nbsp;_JsonGetTUString(pArrayItem,&nbsp;"name");</p>
<p>//解析出子频道</p>
<p>_ParseSubChnls(tChannelData.m_aSubChnlList,&nbsp;pArrayItem);</p>
<p>//将大频道信息对象压入列表中</p>
<p>m_aChnlsList.push_back(tChannelData);</p>
<p>}</p>
<p>else</p>
<p>{</p>
<p>continue;</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p>/**&nbsp;&nbsp;解析子频道</p>
<p>*</p>
<p>*&nbsp;\param&nbsp;aSubChnlList&nbsp;存放子频道数据的vector对象</p>
<p>*&nbsp;\param&nbsp;pCJson&nbsp;cJSON对象指针</p>
<p>*</p>
<p>*&nbsp;\return&nbsp;void</p>
<p>*/</p>
<p>void&nbsp;TChannelsData::_ParseSubChnls(vector&amp;&nbsp;aSubChnlList,&nbsp;cJSON*&nbsp;pCJson)</p>
<p>{</p>
<p>cJSON*&nbsp;pJsonArray&nbsp;=&nbsp;NULL;</p>
<p>if&nbsp;(!pCJson)</p>
<p>{</p>
<p>return;</p>
<p>}</p>
<p>pJsonArray&nbsp;=&nbsp;cJSON_GetObjectItem(pCJson,&nbsp;"subchnls");</p>
<p>if&nbsp;(pJsonArray)</p>
<p>{</p>
<p>cJSON*&nbsp;pArrayItem&nbsp;=&nbsp;NULL;</p>
<p>//cJSON*&nbsp;pJsonTemp&nbsp;=&nbsp;NULL;</p>
<p>Int32&nbsp;nSize&nbsp;=&nbsp;cJSON_GetArraySize(pJsonArray);</p>
<p>for&nbsp;(Int32&nbsp;i&nbsp;=&nbsp;0;&nbsp;i&nbsp;&lt;&nbsp;nSize;&nbsp;i++)</p>
<p>{</p>
<p>pArrayItem&nbsp;=&nbsp;cJSON_GetArrayItem(pJsonArray,&nbsp;i);</p>
<p>if&nbsp;(pArrayItem)</p>
<p>{</p>
<p>SUBCHNL_DATA&nbsp;tSubChnlData;</p>
<p>Int32&nbsp;nLen&nbsp;=&nbsp;0;</p>
<p>//get&nbsp;title</p>
<p>tSubChnlData.m_title&nbsp;=&nbsp;_JsonGetTUString(pArrayItem,&nbsp;"title");</p>
<p>//get&nbsp;link</p>
<p>tSubChnlData.m_link&nbsp;=&nbsp;_JsonGetString(pArrayItem,&nbsp;"link");</p>
<p>//get&nbsp;desc</p>
<p>tSubChnlData.m_desc&nbsp;=&nbsp;_JsonGetTUString(pArrayItem,&nbsp;"desc");</p>
<p>aSubChnlList.push_back(tSubChnlData);</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p>/**&nbsp;获取指定的cJSON对象的指定属性值</p>
<p>*</p>
<p>*&nbsp;\param&nbsp;pJsonItem&nbsp;cJSON对象指针</p>
<p>*&nbsp;\param&nbsp;pszKey&nbsp;cJSON对象属性</p>
<p>*</p>
<p>*&nbsp;\return&nbsp;返回JSON对象的值，以TUChar字串形式返回</p>
<p>*/</p>
<p>TUChar*&nbsp;TChannelsData::_JsonGetTUString(cJSON*&nbsp;pJsonItem,&nbsp;char*&nbsp;pszKey)</p>
<p>{</p>
<p>TUChar*&nbsp;pszValue&nbsp;=&nbsp;NULL;</p>
<p>Int32&nbsp;nLen;</p>
<p>cJSON*&nbsp;pJsonTemp&nbsp;=&nbsp;NULL;</p>
<p>pJsonTemp&nbsp;=&nbsp;cJSON_GetObjectItem(pJsonItem,&nbsp;pszKey);</p>
<p>if&nbsp;(pJsonTemp)</p>
<p>{</p>
<p>nLen&nbsp;=&nbsp;strlen(pJsonTemp-&gt;valuestring)&nbsp;+&nbsp;1;</p>
<p>pszValue&nbsp;=&nbsp;new&nbsp;TUChar[nLen];</p>
<p>if(pszValue)</p>
<p>{</p>
<p>MemSet(pszValue,&nbsp;0,&nbsp;nLen&nbsp;*&nbsp;sizeof(TUChar));</p>
<p>TUString::StrUtf8ToStrUnicode(pszValue,&nbsp;(const&nbsp;Char*)pJsonTemp-&gt;valuestring);</p>
<p>}</p>
<p>}</p>
<p>return&nbsp;pszValue;</p>
<p>}</p>
<p>/**&nbsp;获取指定的cJSON对象的指定属性值</p>
<p>*</p>
<p>*&nbsp;\param&nbsp;pJsonItem&nbsp;cJSON对象指针</p>
<p>*&nbsp;\param&nbsp;pszKey&nbsp;cJSON对象属性</p>
<p>*</p>
<p>*&nbsp;\return&nbsp;返回JSON对象的值，以char字串形式返回</p>
<p>*/</p>
<p>char*&nbsp;TChannelsData::_JsonGetString(cJSON*&nbsp;pJsonItem,&nbsp;char*&nbsp;pszKey)</p>
<p>{</p>
<p>char*&nbsp;pszValue&nbsp;=&nbsp;NULL;</p>
<p>Int32&nbsp;nLen;</p>
<p>cJSON*&nbsp;pJsonTemp&nbsp;=&nbsp;NULL;</p>
<p>pJsonTemp&nbsp;=&nbsp;cJSON_GetObjectItem(pJsonItem,&nbsp;pszKey);</p>
<p>if&nbsp;(pJsonTemp)</p>
<p>{</p>
<p>nLen&nbsp;=&nbsp;strlen(pJsonTemp-&gt;valuestring)&nbsp;+&nbsp;1;</p>
<p>pszValue&nbsp;=&nbsp;new&nbsp;char[nLen];</p>
<p>if(pszValue)</p>
<p>{</p>
<p>MemSet(pszValue,&nbsp;0,&nbsp;nLen);</p>
<p>strncpy(pszValue,&nbsp;pJsonTemp-&gt;valuestring,&nbsp;nLen&nbsp;-&nbsp;1);</p>
<p>}</p>
<p>}</p>
<p>return&nbsp;pszValue;</p>
<p>}</p>
<p>/**&nbsp;获取指定的cJSON对象的指定属性值</p>
<p>*</p>
<p>*&nbsp;\param&nbsp;pJsonItem&nbsp;cJSON对象指针</p>
<p>*&nbsp;\param&nbsp;pszKey&nbsp;cJSON对象属性</p>
<p>*</p>
<p>*&nbsp;\return&nbsp;返回JSON对象的值，以int32形式返回</p>
<p>*/</p>
<p>Int32&nbsp;TChannelsData::_JsonGetInt(cJSON*&nbsp;pJsonItem,&nbsp;char*&nbsp;pszKey)</p>
<p>{</p>
<p>Int32&nbsp;nValue&nbsp;=&nbsp;0;</p>
<p>cJSON*&nbsp;pJsonTemp&nbsp;=&nbsp;NULL;</p>
<p>pJsonTemp&nbsp;=&nbsp;cJSON_GetObjectItem(pJsonItem,&nbsp;pszKey);</p>
<p>if&nbsp;(pJsonTemp)</p>
<p>{</p>
<p>nValue&nbsp;=&nbsp;pJsonTemp-&gt;valueint;</p>
<p>}</p>
<p>return&nbsp;nValue;</p>
<p>}</p>
<p>/**&nbsp;获取指定的cJSON对象的指定属性值</p>
<p>*</p>
<p>*&nbsp;\param&nbsp;pJsonItem&nbsp;cJSON对象指针</p>
<p>*&nbsp;\param&nbsp;pszKey&nbsp;cJSON对象属性</p>
<p>*</p>
<p>*&nbsp;\return&nbsp;返回JSON对象的值，以Boolean形式返回</p>
<p>*/</p>
<p>Boolean&nbsp;TChannelsData::_JsonGetBoolean(cJSON*&nbsp;pJsonItem,&nbsp;char*&nbsp;pszKey)</p>
<p>{</p>
<p>Boolean&nbsp;bValue&nbsp;=&nbsp;FALSE;</p>
<p>cJSON*&nbsp;pJsonTemp&nbsp;=&nbsp;NULL;</p>
<p>pJsonTemp&nbsp;=&nbsp;cJSON_GetObjectItem(pJsonItem,&nbsp;pszKey);</p>
<p>if&nbsp;(pJsonTemp)</p>
<p>{</p>
<p>if(pJsonTemp-&gt;valueint)</p>
<p>{</p>
<p>bValue&nbsp;=&nbsp;TRUE;</p>
<p>}</p>
<p>}</p>
<p>return&nbsp;bValue;</p>
<p>}</p>
</div>
<p>总结：</p>
<p>JSON的结构简约，所以使得JSON的文档的数据量比较小，比较适合用于网络数据的交换，而且对JSON文档的解析和数据提取的方法也很简单，方便程序员的使用，当然也正是因为JSON的结构简约，使得JSON的可读性与可编辑性会稍差于XML，所以JSON比较适合在较少有人工阅读和编辑的情况下使用期。</p>
<p>备注：经验证名称需加&ldquo;&nbsp;比如char&nbsp;jsonString[]&nbsp;=&nbsp;"{\"result\":true}";</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390rjmj9.html">招聘&period;NET开发人员&lpar;截止于2015-06-15&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvzy6j9.html">&period;md文件的语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/49523ye9.html">Winform屏幕截图保存C&num;代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnp6vj8.html">CoreAnimation-01-CALayer核心要点及实例解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1nd7k8.html">C语言开源项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1vmw39.html">openerp 7 在ubuntu上设置开机启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1r4k39.html">fopen警告处理方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1z5z38.html">【模拟】Codeforces 710C Magic Odd Square</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd6pdr8.html">fs&period;rename可以重新写入文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ye2oeq.html">java的表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gepww48.html">&lbrack;妙味DOM&rsqb;第一课：DOM基础概念、操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9507lmv8.html">oracle数据库管理系统常见的错误&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pxpdn8.html">Java 8中用法优雅的Stream，性能也&amp;quot&semi;优雅&amp;quot&semi;吗？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljy24e9.html">java&lpar;7&rpar;数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wx3rnq.html">zabbix监控Apache</a>
		</li>
						<li><a href="https://www.batexi.com/a/9603e4y9.html">return关键字的作用和接受实验</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jdkr5q.html">JAVA第三周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll75vxq.html">System&period;Data&period;SqlClient&period;SqlException&colon;&OpenCurlyDoubleQuote;对象名 &amp;&num;39&semi;customer&amp;&num;39&semi; 无效。&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdpnde9.html">Android Studio安装插件提示was not installed&colon; Cannot download的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllyklxq.html">C&plus;&plus;程序生成&period;exe文件，在文件夹中运行时闪现问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8mg1k28.html">eBay 消息发送（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/390oor49.html">POJ 2217 &lpar;后缀数组&plus;最长公共子串&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gln4zq.html">【BZOJ】1834&colon; &lbrack;ZJOI2010&rsqb;network 网络扩容（最大流&plus;费用流）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49glng0q.html">【Vijos】1792 摆花</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd60ev8.html">POST模拟百度登录和自动发帖</a>
			</li>
						<li><a href="https://www.batexi.com/a/390w7r4q.html">&period;NET正则基础之&mdash;&mdash;平衡组</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1gmwzq.html">如何获取checkboxlist的多个选中项</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8epezm9.html">如何在spring框架中解决多数据源的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k3113q.html">NSString 处理技巧：分割字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/495506m9.html">利用openSSL 生成RSA公钥和密钥</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
